/* **********************************************************************

   ControlShell 5.x interface for the CSFsmResponseModule transition module.
   Includes data input and display functions for the 
   CSFsmResponseModule class.
   Generated automatically by the ControlShell FSM Editor or tmgen.

   Do not modify by hand!

   Generated: Fri Apr 17 17:44:55 1998


   Copyright, 1991-4, Real-Time Innovations, Inc.
_________________________________________________________________________*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "rtilib/makeheader.h"
#include "rtilib/rti_types.h"
#include "rtilib/strtoken.h"
#include "cs.h"
#include "CSDataParse.h"
#include "CSFsm.h"
#include "CSFsmResponseModule.pkg.h"

class CSFsmResponseModuleParseClient : public TransRtnParseClient {

  private:
    CSFsmResponseModule _ds;

  protected:
    virtual void cleanup();

  public:
    CSFsmResponseModuleParseClient( CSParseCmd *, char *key );

    // startRoutine is called directly by CSFsmParseClient, not ParseCmd!
    // These are NOT inherited from the CSParseClient.
    virtual void *startRoutineTr( char *transName, CSFsm fsm );
    virtual ParseStatus lineRoutine( char *token, char *line, int linecount );
    virtual ParseStatus endRoutine( int linecount );

    virtual const char *const className() { 
	return ("CSFsmResponseModuleParseClient");
    }
};

CSFsmResponseModuleParseClient::CSFsmResponseModuleParseClient( 
    CSParseCmd *parseCmd, char *key) 
    : TransRtnParseClient(parseCmd, key)
{
    _ds = NULL;
}

void CSFsmResponseModuleParseClient::cleanup()
{
    _ds = NULL;
}
    
/*
 * The token stream should contain:
 *	CSFsmResponseModule->name [size]
 *
 * Does not run on the first pass.
 * If transition module is already in database and it has no arguments, do not
 *   create new one.
 * Otherwise create a new one.
 */
void *CSFsmResponseModuleParseClient::startRoutineTr( char *transName, CSFsm fsm ) 
{
    if (_parseCmd->pass() == 1) { return (NULL); }

    cleanup();

    // Get from database
    _ds = (CSFsmResponseModule) CSdBaseInquireRecord("TransRtnModule", transName);

    // If not exist, or if have args, create a new one
    if (_ds == NULL || _ds->nArgs() > 0) {
	_ds = new CSFsmResponseModuleClass(fsm, transName);
	_ds->_nArgs = 1;

	_ds->_context             = NULL;

    }
    return(_ds);
}

/*
 * The fieldname is in "token".  The token stream should contain whatever 
 * else is required to initialize the field.  If an error is encountered, 
 * this should return PARSE_ERROR.
 * The algorithm is:
 *    for(all field names) {
 *	if (token == name) {readType(&_ds->name);}
 *    }
 *
 * On first pass, make sure to read CSMats to make sure they exist by 
 *  second pass.
 * On second pass, hook up to _ds
 */
ParseStatus CSFsmResponseModuleParseClient::lineRoutine(
					     char *token, 
					     char *line, 
					     int count)
{
    ParseStatus ret = PARSE_OK;

    if (_parseCmd->pass() == 1) {
	// First pass just creates csmats.
	/* Read the fields */
	if (strcmp("context;", token) == 0) {
	    ret = readString(token, NULL);
	} else  
	{
	    fprintf(stderr, "**** Error: %s lineRoutine"
		    ": Bad field (%s)\n", key(), token);
	    return(PARSE_ERROR);
	}
    } else {
	// Second pass assigns the arguments
	if (!_ds) {
	    fprintf(stderr, "**** Error: %s lineRoutine"
		    ": data not initialized\n", key());
	    return(PARSE_ERROR);
	}
	
	/* Read the fields */
	if (strcmp("context;", token) == 0) {
	    ret = readString(token, &_ds->_context);
	} else  
	{
	    fprintf(stderr, "**** Error: %s lineRoutine"
		    ": Bad field (%s)\n", key(), token);
	    return(PARSE_ERROR);
	}
    }
    return(ret);
}

/*
 * Instance the newly read CSFsmResponseModule to perform any 
 *  user initializations, and print it if verbosity is enabled.
 *
 * This is not run on the first pass.
 */
ParseStatus CSFsmResponseModuleParseClient::endRoutine(
    int total)
{
    // Do nothing on first pass!
    if (_parseCmd->pass() == 1) {
	return(PARSE_OK);
    }
    if (!_ds) {
	fprintf(stderr, "**** Error: %s endRoutine"
		": data not initialized\n", key());
	return(PARSE_ERROR);
    }
    
    if (_ds->instance() == NULL) {
	return (PARSE_ERROR);
    }
    _ds->print(_parseCmd->verbosity());
    _ds->verified(TRUE);
    return(PARSE_OK);
}

/* verbosity:
	 0: do nothing
	 1: print only one line with CSFsmResponseModule name
	 2: print one line per field.
	 3: print gory detail for each field.
*/	
boolean CSFsmResponseModuleClass::print( int verbosity )
{
    if (verbosity <= 0) { return(TRUE); }

    printf("%s:\n", className());

    verbosity--;	/* Decrement the verbosity for the field prints. */

    /* Print the fields. */
    printString("context", _context, verbosity);


    return(TRUE);
}

int CSFsmResponseModuleClass::getRetcode( char *retcodeName )
{
    if (strcmp("OK", retcodeName) == 0) {
	return (RET_OK);
    } else 
    {
	return (-1);
    }
}

#pragma begin_Package
#ifdef __cplusplus
extern "C" {
#endif
#pragma end_Package

Package
void CSFsmResponseModuleInit( CSParseCmd *parseCmd )
{
    new CSFsmResponseModuleParseClient(parseCmd,
				 "_CSTM_CSFsmResponseModule");
    CSFsmResponseModuleInitialize();
}

#pragma begin_Package
#ifdef __cplusplus
}    /* extern "C" */
#endif
#pragma end_Package

/* End of file */
