
import netscape.application.Color;

/*
 * This represents an arbitrary C/C++ Expression.
 */

public class DataDeclarationStatement extends DataStatement
{
	/* Class Constants. */
  public final static int      PARSE_GUI_DECLARATION_STATEMENT = 5002;
  public final static String   FIRST_TOKEN_INDEX = "First";

	/* Class Variables */
  public       static Color    DECLARATION_COLOR = Color.pink;

	/* Instance Variables */

	/* Instance Methods */
  public DataDeclarationStatement()
  {
  }


  public DataComponent newComponent ( )
  {
    DataDeclarationStatement  statement = new DataDeclarationStatement();

    statement . addSubcomponent ( "\n" );

    return statement;
  }


  public String getWarnString ( int      theObjectSubset,
				boolean  theIsGenerating )
  {
    return super . getWarnString ( theObjectSubset, theIsGenerating )
	     + " or DataDeclarationStatement.PARSE_GUI_DECLARATION_STATEMENT ("
	     + DataDeclarationStatement.PARSE_GUI_DECLARATION_STATEMENT + ")";
  }

  public boolean isValidObjectSubset ( int      theObjectSubset,
				       boolean  theIsGenerating )
  {
    if ( theObjectSubset
	   == DataDeclarationStatement.PARSE_GUI_DECLARATION_STATEMENT )
      return true;
    else
      return super . isValidObjectSubset ( theObjectSubset, theIsGenerating );
  }


  protected
    DataComponent parseSpecificComponent ( TDLParser theTDLParser,
					   int       theObjectSubsetToParse )
    throws Exception
  {
    warnIfInvalidObjectSubset ( theObjectSubsetToParse,
				"parseSpecificComponent", false );
    return theTDLParser . parseDeclarationStatement ( 0 );
  }


  public boolean setFrom ( DataComponent  theObjectToCopy,
			   int            theObjectSubsetToSet,
			   boolean        theCanDestroyObject  )
  {
    if ( /*NOT*/ !  ( theObjectToCopy instanceof DataDeclarationStatement) )
    {
      System.err.println ( "[DataDeclarationStatement:setFrom]  Error:  "
			   + "Illegal object.  (\""
			   + theObjectToCopy . getClass() . getName()
			   + "\")" );
      return false;
    }

    boolean   returnValue;

    returnValue =  super . setFrom ( theObjectToCopy, theObjectSubsetToSet,
				     theCanDestroyObject );

	/* Kludge to add "\n"'s to GUI-parsed jump-statements */
    if (   ( returnValue                                            == true )
	&& ( theObjectSubsetToSet
	        == DataDeclarationStatement.PARSE_GUI_DECLARATION_STATEMENT ) )
    {
      addSubcomponent ( "\n", 0 );
    }

    return returnValue;
  }


  public void generate ( DataDestination  theOutputDestination,
			 int              theObjectSubsetToGenerate )
  {
	/* Hack to deal with GUI-parsing... */
    if ( theObjectSubsetToGenerate
	   == DataDeclarationStatement.PARSE_GUI_DECLARATION_STATEMENT )
      theObjectSubsetToGenerate = DataComponent . ENTIRE_OBJECT;


       	/* Print a warning if necessary... */
    warnIfInvalidObjectSubset ( theObjectSubsetToGenerate, "generate", true );

    	/* Initialize us to generate non-significant tokens... */
    initializeGenerateSubcomponentIndex();

	/* Generate any labels that we have... */
    generateLabels ( theOutputDestination, theObjectSubsetToGenerate,
		     DataDeclarationStatement.FIRST_TOKEN_INDEX );

	/* And generate all of our tokens, since we are (currently)
	 * just a token-list
	 */
    generateAllRemainingSubcomponents ( theOutputDestination,
					theObjectSubsetToGenerate, false );
  }



	/********************************************************/
        /********** Methods to interface with Graphing **********/
	/********************************************************/
  public boolean supportsGraphType ( int theGraphType )
  {
    if (   ( theGraphType == GraphRoot.GUI_TREE_GRAPH ) )
      return true;
    else
      return false;
  }

  public GraphModule createGraphModule ( int theGraphType )
  {
    if (   ( theGraphType != GraphRoot.GUI_TREE_GRAPH ) )
      return null;

    /* else ... */

    /* Building:  +- "[.]"
     *            |
     */

    ScrollTextOfDataComponent  declarationText
				 = new ScrollTextOfDataComponent ( this,
		    DataDeclarationStatement.PARSE_GUI_DECLARATION_STATEMENT );

    GraphNode       declarationNode = new GraphNode ( declarationText,
						      GraphComponent.LEFT,
						      DataDeclarationStatement
						        . DECLARATION_COLOR,
						      true, null );
						     
    GraphConnection toDeclaration = new GraphConnection ( GraphComponent.LEFT,
						       DataDeclarationStatement
							 . DECLARATION_COLOR,
						       false, false,
						       declarationNode );

    GraphMeet       startMeet = new GraphMeet ( GraphComponent.UP,
						DataDeclarationStatement
						 . DECLARATION_COLOR,
						GraphComponent.LEFT,
						toDeclaration );

    GraphConnection tail = new GraphConnection ( GraphComponent.UP,
					     DataComponent.getDraggableColor(),
					     true, true, null );
    startMeet . addChild ( tail );

    return new GraphModule ( startMeet, tail, null, null,
			     this, true, theGraphType );
  }

	/* Invoked by this.update(*) invoking GraphModule.update() */
  public boolean updateGraphModule ( DataComponent  theModifiedComponent,
				     Object         theStoredData,
				     GraphModule    theGraphModule )
  {
	/* There is nothing to do here.. */
    return true;
  }

}
