
#define _TDL_INTERNAL_
#include <tdl.H>

	/* Create this as a global, so that spawns outside of tasks can
	 * refer to "PARENT".  (Ie: For the #define to work right...)
	 * Now used in place of TCM_RootNode() to provide a rather hideous
	 * mechanism for inserting external nodes (spawns outside of tasks)
	 * into the TCM Task Tree at locations other than the TCM_RootNode.
	 */
/* Definition for extern in tdl.H */
TCM_Task_Tree_Ref const & _TDL_ENCLOSING_TASK = TCM_RootNode();



/*static*/
u_int4 TDL::reportingLevel = 
#ifdef _TDL_REPORTING_LEVEL
				     _TDL_REPORTING_LEVEL ;
#else
				     TDL::EVERYTHING ;
#endif


/*static*/
BOOLEAN TDL::closeLogStream = FALSE;

/*static*/
ostream * TDL::logStream    = & cerr;



	/* Returns TRUE for direct instances [SPAWN foo();],   *
	 * both Monitor and Monitor-child instances ["ACT-"],  *
	 * and SPAWN-with-WAIT macro instances ["-auto,wait"]. */
/*static*/ BOOLEAN
TDL::checkForTaskInstanceOf ( const char * theActualTaskName,
			      const char * theNameToCheck )
{
  if ( theActualTaskName == (const char *)NULL )
  {
    cerr << "[TDL::checkForTaskInstanceOf]  Error:  theActualTaskName is NULL."
	 << endl;
    return FALSE;
  }

  if ( theNameToCheck == (const char *)NULL )
  {
    cerr << "[TDL::checkForTaskInstanceOf]  Error: theNameToCheck is NULL."
	 << endl;
    return FALSE;
  }

  if ( StringEqual ( theActualTaskName, theNameToCheck ) == TRUE )
    return TRUE;

	/* Monitor child case -- Treat as instance of... */
  if (   ( strlen  ( theActualTaskName            ) >  4 )
      && ( strncmp ( theActualTaskName, "ACT-", 4 ) == 0 ) )
  {
    theActualTaskName += 4;

    if ( StringEqual ( theActualTaskName, theNameToCheck ) == TRUE )
      return TRUE;
  }

	/* Created through SpawnAndWait auto-generated function/macro case */
	/* theActualTaskName = theNameToCheck + "-auto,wait"               */
  if (   ( strlen ( theActualTaskName ) > strlen ( theNameToCheck )        )
      && ( strncmp ( theActualTaskName, theNameToCheck,
		     strlen ( theNameToCheck )                      ) == 0 )
      && ( strcmp  ( theActualTaskName + strlen ( theNameToCheck ),
		     "-auto,wait"                                   ) == 0 ) )
  {
    return TRUE;
  }

  return FALSE;
}
